//+------------------------------------------------------------------+
//|                              YG_STF_CCI_3TF_NR.mq4                                                             
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "YG_STF_CCI_3TF_NR"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime//MediumSeaGreen
#property indicator_width1 3
#property indicator_color2 EMPTY   
#property indicator_color3 Red
#property indicator_width3 3
#property indicator_color4 EMPTY 

#property indicator_maximum 1//600                     
#property indicator_minimum -1//600

//=============================================================
#property indicator_level1 0
//#property indicator_level3 300
//#property indicator_level2 -300
#property indicator_levelcolor BurlyWood  
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 0

//============================ INPUT ==========================
extern double CCIPerA   = 21;//15
extern double CCIPerB   = 5 ;  
extern double CCIPerC   = 5 ;    
//===========================================================

extern int   LineSize1    = 3 ;
extern int   LineSize2    = 1 ;
extern int   LineSize3    = 2 ;
extern int   CountBars    = 600 ;
extern bool  NoName       = false ;

extern int    TFA  = 0 ;    
extern int    TFB  = 0 ;
extern int    TFC  = 0 ;

bool   StepTFA_Up   =  true; 
bool   StepTFB_Up   =  true; 
bool   StepTFC_Up   =  true; 

double MapBuffer1[];
double MapBuffer2[];
double MapBuffer3[];
double MapBuffer4[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(+0);
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,LineSize1);
   SetIndexBuffer(0,MapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,LineSize2);
   SetIndexBuffer(1,MapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,LineSize1);
   SetIndexBuffer(2,MapBuffer3);
   
    SetIndexStyle(3,DRAW_LINE,EMPTY,LineSize3);
   SetIndexBuffer(3,MapBuffer4);

//========================================================================================
     switch(TFA)   {    case 1 : string TimeFrameStrA="Period_M1"; break;
                        case 5 : TimeFrameStrA="Period_M5"; break;
                       case 15 : TimeFrameStrA="Period_M15"; break;
                       case 30 : TimeFrameStrA="Period_M30"; break;
                       case 60 : TimeFrameStrA="Period_H1"; break;
                      case 240 : TimeFrameStrA="Period_H4"; break;
                     case 1440 : TimeFrameStrA="Period_D1"; break;
                    case 10080 : TimeFrameStrA="Period_W1"; break;
                    case 43200 : TimeFrameStrA="Period_MN1"; break;
                       default : TimeFrameStrA="Current Timeframe";
                   SetStepTFA_Up();
                 }
//=======================================================================================      
    switch(TFB)   {     case 1 : string TimeFrameStrB="Period_M1"; break;
                        case 5 : TimeFrameStrB="Period_M5"; break;
                       case 15 : TimeFrameStrB="Period_M15"; break;
                       case 30 : TimeFrameStrB="Period_M30"; break;
                       case 60 : TimeFrameStrB="Period_H1"; break;
                      case 240 : TimeFrameStrB="Period_H4"; break;
                     case 1440 : TimeFrameStrB="Period_D1"; break;
                    case 10080 : TimeFrameStrB="Period_W1"; break;
                    case 43200 : TimeFrameStrB="Period_MN1"; break;
                       default : TimeFrameStrB="Current Timeframe";
                   SetStepTFB_Up();
                  }
//=======================================================================================     
    switch(TFC)    {    case 1 : string TimeFrameStrC="Period_M1"; break;
                        case 5 : TimeFrameStrC="Period_M5"; break;
                       case 15 : TimeFrameStrC="Period_M15"; break;
                       case 30 : TimeFrameStrC="Period_M30"; break;
                       case 60 : TimeFrameStrC="Period_H1"; break;
                      case 240 : TimeFrameStrC="Period_H4"; break;
                     case 1440 : TimeFrameStrC="Period_D1"; break;
                    case 10080 : TimeFrameStrC="Period_W1"; break;
                    case 43200 : TimeFrameStrC="Period_MN1"; break;
                       default : TimeFrameStrC="Current Timeframe";
                    SetStepTFC_Up();
                  }               
//=======================================================================================  
 
      string short_name;
      IndicatorShortName("CCI_3TF");
      SetIndexLabel(0,"CCI_3TF");
//======================================================================================      
         }
          return(0);
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
  {     Refresh();
        return(0);
  }          
//+--------------------------------------------------------------------------------------+
int start()
  {  Refresh();
     datetime TimeArray[]; datetime TimeArray1[]; datetime TimeArray2[];
   
     int i,limit,counted_bars=IndicatorCounted();
     int y=0,y1=0,y2=0;
     
    ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TFA); 
    ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TFB); 
    ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),TFC); 

 
   limit=Bars-counted_bars;
//==============================================================================================       
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
    
// ------------------  laat laaste 2 kerse repaint(smooth)--------------------------------       
   //   if(counted_bars>0) limit++; else if (limit>100) limit=CountBars;  

//========================  SHORTNAME  ==============================================================         
           if  ( NoName == false  )
         {    string  ThisName1 = "(CCI-3TF)";
              string Text1=ThisName1;
              Text1=Text1+"(TF "+TFA;
              Text1=Text1+"/"+TFB;
              Text1=Text1+"/"+TFC;
              Text1=Text1+")";
              Text1=Text1+"(";
              Text1=Text1+" "+DoubleToStr(CCIPerA,0);
              Text1=Text1+","+DoubleToStr(CCIPerB,0);
              Text1=Text1+","+DoubleToStr(CCIPerC,0);
              Text1=Text1+")";
              IndicatorShortName(Text1); 
               SetIndexLabel(0,"(CCI-3TF)");
         }  
//===============================================================================================          
    
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y])   y++;  
      if (Time[i]<TimeArray1[y1]) y1++;  
      if (Time[i]<TimeArray2[y2]) y2++;   
      
//=======================  HEADINGE  =============================================================   
    {    
     ObjectCreate ("HEAD_CCI3TF", OBJ_LABEL,WindowFind("CCI-3TF"), 0, 0);
     ObjectSetText("HEAD_CCI3TF", "CCI-3TF" , 8, "Tahoma Narrow", Gold);
     ObjectSet    ("HEAD_CCI3TF", OBJPROP_CORNER, 1);
     ObjectSet    ("HEAD_CCI3TF", OBJPROP_XDISTANCE, 20);
     ObjectSet    ("HEAD_CCI3TF", OBJPROP_YDISTANCE, 5 ); 
   }

//===================== RSI A ========================================================================
      double totalUp = 0.0;
      
      totalUp=               iCCI(NULL, TFA, CCIPerA, PRICE_TYPICAL, y);
      totalUp= totalUp     + iCCI(NULL, TFB, CCIPerB, PRICE_TYPICAL, y1);
      totalUp= totalUp     + iCCI(NULL, TFC, CCIPerC, PRICE_TYPICAL, y2);
         
 //===============================================================================================  
  
      MapBuffer1[i] = 0;
      MapBuffer2[i] = 0;
      MapBuffer3[i] = 0;
      MapBuffer4[i] = 0;
      
      
      if ( totalUp > 0 )
         MapBuffer1[i] = totalUp;
         MapBuffer4[i] = totalUp;
    
      
      if ( totalUp < 0 )
         MapBuffer3[i] = totalUp;           
      
 //=====================================================================================
      } 
        return(0);
     }
 //================================================================================== ++       
             void SetValuesA(int pA)  {  TFA = pA;        }                                   
        void SetStepTFA_Up()     {  switch (Period() )                
           {  case PERIOD_M1  :  SetValuesA(PERIOD_M1);  break;       
              case PERIOD_M5  :  SetValuesA(PERIOD_M5);  break;         
              case PERIOD_M15 :  SetValuesA(PERIOD_M15); break;     
              case PERIOD_M30 :  SetValuesA(PERIOD_M30); break;            
              case PERIOD_H1  :  SetValuesA(PERIOD_H1);  break;               
              case PERIOD_H4  :  SetValuesA(PERIOD_H4);  break;                
              case PERIOD_D1  :  SetValuesA(PERIOD_D1);  break;                
              case PERIOD_W1  :  SetValuesA(PERIOD_W1);  break;             
              case PERIOD_MN1 :  SetValuesA(PERIOD_MN1); break;                   
           } }    

//==============================step timeframe up TF1====================================  
       void SetValuesB(int pB) { TFB = pB;        }                                    
       void SetStepTFB_Up()   { switch (Period() )                
           { case PERIOD_M1  :  SetValuesB(PERIOD_M5);    break;       
             case PERIOD_M5  :  SetValuesB(PERIOD_M15);   break;         
             case PERIOD_M15 :  SetValuesB(PERIOD_M30);   break;     
             case PERIOD_M30 :  SetValuesB(PERIOD_H1);    break;            
             case PERIOD_H1  :  SetValuesB(PERIOD_H4);    break;               
             case PERIOD_H4  :  SetValuesB(PERIOD_D1);    break;                
             case PERIOD_D1  :  SetValuesB(PERIOD_W1);    break;                
             case PERIOD_W1  :  SetValuesB(PERIOD_MN1);   break;             
             case PERIOD_MN1 :  SetValuesB(PERIOD_MN1);   break;                   
          } }   
//============================== TF2 ===================================================     
       void SetValuesC(int pC) {  TFC = pC;         }                                    
       void SetStepTFC_Up()    {  switch (Period()  )                
          { case PERIOD_M1  :  SetValuesC(PERIOD_M15);  break;       
            case PERIOD_M5  :  SetValuesC(PERIOD_M30);  break;         
            case PERIOD_M15 :  SetValuesC(PERIOD_H1);   break;     
            case PERIOD_M30 :  SetValuesC(PERIOD_H4);   break;            
            case PERIOD_H1  :  SetValuesC(PERIOD_D1);   break;               
            case PERIOD_H4  :  SetValuesC(PERIOD_W1);   break;                
            case PERIOD_D1  :  SetValuesC(PERIOD_MN1);  break;                
            case PERIOD_W1  :  SetValuesC(PERIOD_MN1);  break;             
            case PERIOD_MN1 :  SetValuesC(PERIOD_MN1);  break;                   
         } }    

 //====================================================================
void Refresh() 
   {         ObjectDelete("HEAD_CCI3TF");     
      
   }
 
//------------------------------------------------------------------------------------+ 

